version: '3.7'
services:
  app:
    image: node:10
    volumes:
      - ../../../:/app
    working_dir: /app
    command: /app/src/.buildkite/publish/run.sh
    environment:
      # PostgreSQL
      - TEST_POSTGRES_URI_MIGRATE=postgres://prisma:prisma@postgres:5432/tests-migrate
      - TEST_POSTGRES_SHADOWDB_URI_MIGRATE=postgres://prisma:prisma@postgres:5432/tests-migrate-shadowdb
      - TEST_POSTGRES_BASE_URI=postgres://prisma:prisma@postgres:5432
      - TEST_POSTGRES_URI=postgres://prisma:prisma@postgres:5432/tests
      - TEST_POSTGRES_ISOLATED_URI=postgres://prisma:prisma@postgres_isolated:5432/tests
      # MySQL
      - TEST_MYSQL_URI_MIGRATE=mysql://root:root@mysql:3306/tests-migrate
      - TEST_MYSQL_SHADOWDB_URI_MIGRATE=mysql://root:root@mysql:3306/tests-migrate-shadowdb
      - TEST_MYSQL_BASE_URI=mysql://root:root@mysql:3306
      - TEST_MYSQL_URI=mysql://root:root@mysql:3306/tests
      - TEST_MYSQL_ISOLATED_URI=mysql://root:root@mysql_isolated:3306/tests
      # MariaDB
      - TEST_MARIADB_BASE_URI=mysql://root:root@mariadb:3306
      - TEST_MARIADB_URI=mysql://root:root@mariadb:3306/tests
      # SQL Server
      - TEST_MSSQL_URI=mssql://SA:Pr1sm4_Pr1sm4@mssql:1433/master
      - TEST_MSSQL_JDBC_URI=sqlserver://mssql:1433;database=master;user=SA;password=Pr1sm4_Pr1sm4;trustServerCertificate=true;encrypt=DANGER_PLAINTEXT
      - TEST_MSSQL_JDBC_URI_MIGRATE=sqlserver://mssql:1433;database=tests-migrate;user=SA;password=Pr1sm4_Pr1sm4;trustServerCertificate=true;encrypt=DANGER_PLAINTEXT
      - TEST_MSSQL_SHADOWDB_JDBC_URI_MIGRATE=sqlserver://mssql:1433;database=tests-migrate-shadowdb;user=SA;password=Pr1sm4_Pr1sm4;trustServerCertificate=true;encrypt=DANGER_PLAINTEXT
      # Other vars
      - NPM_TOKEN
      - GITHUB_TOKEN
      - UPDATE_STUDIO
      - BUILDKITE
      - BUILDKITE_TAG
      - BUILDKITE_BRANCH
      - RELEASE_PROMOTE_DEV
      - PUBLISH_BUILD=true
      - REDIS_URL
      - MIGRATE_COMMIT
      - PRISMA_CLIENT_JS_COMMIT
      - PRISMA2_COMMIT
      - DEVELOPMENT_ENVIRONMENT_COMMIT
      - PATCH_BRANCH
      - DRY_RUN
      - CI
      - PRISMA_TELEMETRY_INFORMATION="buildkite prisma publish"
      - SKIP_E2E_CHECK
      - SLACK_RELEASE_FEED_WEBHOOK
    depends_on:
      - postgres
      - postgres_isolated
      - mysql
      - mariadb
      - mssql

  postgres:
    image: postgres:10
    restart: always
    environment:
      - POSTGRES_DB=tests
      - POSTGRES_USER=prisma
      - POSTGRES_PASSWORD=prisma
    volumes:
      - postgres:/var/lib/postgresql/data

  postgres_isolated:
    image: postgres:10
    restart: always
    environment:
      - POSTGRES_DB=tests
      - POSTGRES_USER=prisma
      - POSTGRES_PASSWORD=prisma
    volumes:
      - postgres_isolated:/var/lib/postgresql/data

  mysql:
    image: mysql:8.0
    command: --default-authentication-plugin=mysql_native_password
    restart: always
    environment:
      - MYSQL_ROOT_PASSWORD=root
      - MYSQL_DATABASE=tests
      - MYSQL_USER=prisma
      - MYSQL_PASSWORD=prisma
    volumes:
      - mysql:/var/lib/mysql

  mysql_isolated:
    image: mysql:8.0
    command: --default-authentication-plugin=mysql_native_password
    restart: always
    environment:
      - MYSQL_ROOT_PASSWORD=root
      - MYSQL_DATABASE=tests
      - MYSQL_USER=prisma
      - MYSQL_PASSWORD=prisma
    volumes:
      - mysql_isolated:/var/lib/mysql

  mariadb:
    image: mariadb:10
    restart: always
    environment:
      - MYSQL_ROOT_PASSWORD=root
      - MYSQL_DATABASE=tests
      - MYSQL_USER=prisma
      - MYSQL_PASSWORD=prisma
    volumes:
      - mariadb:/var/lib/mysql

  mssql:
    image: mcr.microsoft.com/mssql/server:2019-latest
    restart: always
    environment:
      - ACCEPT_EULA=Y
      - SA_PASSWORD=Pr1sm4_Pr1sm4
    volumes:
      - mssql:/var/opt/mssql

volumes:
  postgres:
  postgres_isolated:
  mysql:
  mysql_isolated:
  mariadb:
  mssql:
